# draws the left and right vertical bars
proc extreme { base side } {
    global color icons
    frame $base.$side -width 20 -borderwidth 2 -relief ridge \
        -background $color(back)
    bind $base.$side <B1-ButtonPress> {wm command $base.$side WM_MOVE_WINDOW}
    button $base.$side.ico -image $icons($side) -borderwidth 0 \
        -background $color(back) -activebackground $color(back)
    if ![ string compare $side "left" ] {
        $base.$side.ico configure -command {
            $base.pager.col4.load configure -bg yellow
            if { [ catch { exec tkrunit & } ] == 1 } {
# opens a simple exec dialog, but i recommend that you get the tkrunit from web
# - it is far better than mine.
                simple_exec $base
            }
            after 500 "$base.pager.col4.load configure -bg green"
        }
    } else {
        $base.$side.ico configure -command "wm iconify ."
    }
    pack $base.$side.ico -side top
    pack $base.$side -fill y -side left
}

proc simple_exec { base } {
    global color
    if [ winfo exists .runit ] { destroy .runit }
    toplevel .runit -background $color(back)
    label .runit.msg -text "type a command to execute:" \
        -background $color(back) -foreground $color(text)
    entry .runit.cmd -borderwidth 1 \
        -background $color(back) -foreground $color(text)
    focus .runit.cmd
    bind .runit.cmd <KeyPress-Return> "eval \"exec \[.runit.cmd get\] &\"\
        \ndestroy .runit"
    bind .runit <KeyPress-Escape> "destroy .runit"
    pack .runit.msg .runit.cmd -fill x -pady 2 -side top
# i can't use overrideredirect because i lose the keyboard focus... :(
#   wm overrideredirect .runit 1
    set ypos [ winfo height $base ]
    set xpos [ winfo rootx $base.left.ico ]
    wm geometry .runit +$xpos-$ypos
}

# draw the buttons that appears on the panel
proc put_buttons { buttons } {
    global base icons subpanel color
    foreach item $buttons {
        set name [ lindex $item 0 ]
        set command [ lindex $item 1 ]
        set icon $icons([ lindex $item 2 ])
        frame $base.$name -background $color(back)
        if [ info exists subpanel($name) ] {
        button $base.$name.up -image $icons(up) -borderwidth 1 \
            -highlightthickness 0 -background $color(back) \
        -activebackground $color(back) -command "put_subpanel $name"
        balloon_help $base.$name.up $name
        }
        button $base.$name.cmd -image $icon -borderwidth 0 \
            -highlightthickness 0 -background $color(back) \
        -activebackground $color(back) -command "execute \"$command\" 0"
#       balloon_help $base.$name.cmd $command; # [lindex $command 0]
        if [ info exists subpanel($name) ] {
            pack $base.$name.up -side top -fill x }
        pack $base.$name.cmd -side bottom -padx 5 -pady 5 -fill y
        pack $base.$name -side left -fill both
    }
}

# draws the buttons and labels placed on subpanels
proc put_subpanel { name } {
    global base icons subpanel color
    if [ winfo exists .$name ] {
        destroy .$name
        $base.$name.up configure -image $icons(up)
    } else {
        $base.$name.up configure -image $icons(down)
        toplevel .$name -background $color(back)
        foreach item $subpanel($name) {
            set cmd [ lindex $item 0 ]
            set command [ lindex $item 1 ]
            set icon $icons([ lindex $item 2 ])
            frame .$name.fr$cmd -background $color(back)
            bind .$name.fr$cmd <B1-ButtonRelease> \
                "execute \"$command\" $name"
            button .$name.fr$cmd.ico -image "$icon" -borderwidth 0 \
                -background $color(back) -highlightthickness 0 \
                -activebackground $color(back) \
                -command "execute \"$command\" $name"
            button .$name.fr$cmd.lab -text "$cmd" -borderwidth 0 \
                -highlightthickness 0 -background $color(back) \
                -foreground $color(text)\
                -activebackground $color(back) \
                -command "execute \"$command\" $name"
            pack .$name.fr$cmd.ico -side left
            pack .$name.fr$cmd.lab -side right
            pack .$name.fr$cmd -fill x -pady 2 -side top
        }
        wm title .$name "tkpanel"
        set ypos [ winfo height $base ]
        set xpos [ winfo rootx $base.$name.up ]
        wm geometry .$name +$xpos-$ypos
        wm resizable .$name 0 0
    }
}

proc execute { command name} {
    global base icons
    $base.pager.col4.load configure -bg yellow
    if [ regexp "_tkpanel_style_config" $command ] { style_config
    } else "eval \"exec $command &\" "
    if { $name != 0 } {
# if it's from a subpanel, destroy it!
        destroy .$name
        $base.$name.up configure -image $icons(up)
    }
    after 500 "$base.pager.col4.load configure -bg green"
}

# draws the central frame, that have the lock, named desktops, and exit buttons
proc pager { base } {
    global pager_names icons color lock_cmd tcl_platform
    frame $base.pager -borderwidth 1 -relief raise -background $color(back)
    frame $base.pager.col1 -background $color(back)
    frame $base.pager.col2 -background $color(back)
    frame $base.pager.col3 -background $color(back)
    frame $base.pager.col4 -background $color(back)
    button $base.pager.col1.lock -image $icons(lock) -borderwidth 0 \
        -highlightthickness 0 -background $color(back) -padx 0 -pady 0 \
        -command "exec $lock_cmd &" -activebackground $color(back)
    frame $base.pager.col2.frame_top -background $color(back)
    button $base.pager.col2.page1 -text $pager_names(1) -borderwidth 2 \
        -highlightthickness 0 -command { changewindow $base 0 } \
        -fg $color(fore) -bg $color(high) -width 15 \
        -activeforeground $color(fore) -activebackground $color(high)
    button $base.pager.col2.page2 -text $pager_names(2) -borderwidth 2 \
        -highlightthickness 0 -command { changewindow $base 1 } \
        -fg $color(fore) -bg $color(high) -width 15 \
        -activeforeground $color(fore) -activebackground $color(high)
    frame $base.pager.col2.frame_bot -background $color(back)
    frame $base.pager.col3.frame_top -background $color(back)
    button $base.pager.col3.page3 -text $pager_names(3) -borderwidth 2 \
        -highlightthickness 0 -command { changewindow $base 2 } \
        -fg $color(fore) -bg $color(high) -width 15 \
        -activeforeground $color(fore) -activebackground $color(high)
    button $base.pager.col3.page4 -text $pager_names(4) -borderwidth 2 \
        -highlightthickness 0 -command { changewindow $base 3 } \
        -fg $color(fore) -bg $color(high) -width 15 \
        -activeforeground $color(fore) -activebackground $color(high)
    frame $base.pager.col3.frame_bot -background $color(back)
# this frame is an status indicator: green when idle, and yellow when occupied
    frame $base.pager.col4.load -background green -relief sunken \
        -borderwidth 1 -width 20 -height 5
switch $tcl_platform(platform) unix {
    balloon_help $base.pager.col4.load "[exec whoami]@[exec uname -n]\
        \n[exec uname] [exec uname -r] [exec uname -m]" }
    button $base.pager.col4.exit -text "EXIT" -font { helvetica 10 } \
        -borderwidth 0 -padx 0 -pady 0 -command exit \
        -bg $color(back) -fg $color(text) -activebackground $color(back)
    pack $base.pager.col1.lock -side top -padx 2 -pady 4
    pack $base.pager.col2.frame_top -expand 1 -side top
    pack $base.pager.col2.page1 $base.pager.col2.page2 -padx 2 -pady 2 \
        -fill x -side top
    pack $base.pager.col2.frame_bot -expand 1 -side top
    pack $base.pager.col3.frame_top -expand 1 -side top
    pack $base.pager.col3.page3 $base.pager.col3.page4 -padx 2 -pady 2 \
        -fill x -side top
    pack $base.pager.col3.frame_bot  -expand 1 -side top
    pack $base.pager.col4.load -pady 10 -side top
    pack $base.pager.col4.exit -padx 2 -pady 4 -side bottom
    pack $base.pager.col1 $base.pager.col2 $base.pager.col3 \
        $base.pager.col4 -side left -fill y
    pack $base.pager -padx 3 -pady 1 -fill y -side left
}

proc changewindow { base page } {
# this works (?) just for FVWM2 at this time...
    $base.pager.col2.page1 configure -relief raise
    $base.pager.col2.page2 configure -relief raise
    $base.pager.col3.page3 configure -relief raise
    $base.pager.col3.page4 configure -relief raise
    if { $page == 0 } {
        $base.pager.col2.page1 configure -relief sunken
        exec FvwmCommand "gotopage 0 0"
    } elseif { $page == 1 } {
        $base.pager.col2.page2 configure -relief sunken
        exec FvwmCommand "gotopage 0 1"
    } elseif { $page == 2 } {
        $base.pager.col3.page3 configure -relief sunken
        exec FvwmCommand "gotopage 1 0"
    } elseif { $page == 3 } {
        $base.pager.col3.page4 configure -relief sunken
        exec FvwmCommand "gotopage 1 1"
    }
}

