# use the command _tkpanel_style_config in rc file
proc style_config { } {
    global icons_path lock_cmd color base rcfile
    set cfg .style_config
    toplevel $cfg -bg $color(back)
    frame $cfg.l -bg $color(back)
    frame $cfg.l.pix -bg $color(back)
    label $cfg.l.pix.l -text "icons path" -anchor w \
        -bg $color(back) -fg $color(text)
    entry $cfg.l.pix.e -textvariable icons_path -borderwidth 1 \
        -bg $color(back) -fg $color(text)
    frame $cfg.l.lock -bg $color(back)
    label $cfg.l.lock.l -text "lock command" -anchor w \
        -bg $color(back) -fg $color(text)
    entry $cfg.l.lock.e -textvariable lock_cmd -borderwidth 1 \
        -bg $color(back) -fg $color(text)
    frame $cfg.l.d -bg $color(back)
    frame $cfg.l.d.pages -bg $color(back)
    label $cfg.l.d.pages.lab -text "page names" \
        -bg $color(back) -fg $color(text)
    entry $cfg.l.d.pages.one -textvariable pager_names(1) \
        -bg $color(back) -fg $color(text) -borderwidth 1
    entry $cfg.l.d.pages.two -textvariable pager_names(2) \
        -bg $color(back) -fg $color(text) -borderwidth 1
    entry $cfg.l.d.pages.thr -textvariable pager_names(3) \
        -bg $color(back) -fg $color(text) -borderwidth 1
    entry $cfg.l.d.pages.four -textvariable pager_names(4) \
        -bg $color(back) -fg $color(text) -borderwidth 1
    frame $cfg.l.d.colors -bg $color(back)
    label $cfg.l.d.colors.lab -text "colors" \
        -bg $color(back) -fg $color(text)
    entry $cfg.l.d.colors.back -textvariable color(back) \
        -bg $color(back) -fg $color(text) -borderwidth 1
    balloon_help $cfg.l.d.colors.back "background color"
    bind $cfg.l.d.colors.back <Double-1> { change_color "back" }
    entry $cfg.l.d.colors.fore -textvariable color(fore) \
        -bg $color(back) -fg $color(text) -borderwidth 1
    balloon_help $cfg.l.d.colors.fore "foreground color"
    bind $cfg.l.d.colors.fore <Double-1> { change_color "fore" }
    entry $cfg.l.d.colors.high -textvariable color(high) \
        -bg $color(back) -fg $color(text) -borderwidth 1
    balloon_help $cfg.l.d.colors.high "high-foreground color"
    bind $cfg.l.d.colors.high <Double-1> { change_color "high" }
    entry $cfg.l.d.colors.text -textvariable color(text) \
        -bg $color(back) -fg $color(text) -borderwidth 1
    balloon_help $cfg.l.d.colors.text "text color"
    bind $cfg.l.d.colors.text <Double-1> { change_color "text" }
    frame $cfg.l.op -bg $color(back)
#   button $cfg.l.op.load -text "load" -command {read_rc $rcfile} \
#        -borderwidth 1 -bg $color(high) -fg $color(fore)
#   balloon_help $cfg.l.op.load "read .tkpanelrc file"
    button $cfg.l.op.set -text "set" -command "set_up_changes $cfg" \
         -borderwidth 1 -bg $color(high) -fg $color(fore)
    balloon_help $cfg.l.op.set "stores internally the values of \
        \nTHIS button/subpanel item"
    button $cfg.l.op.refr -text "refresh" -command "refresh $base" \
        -borderwidth 1 -bg $color(high) -fg $color(fore)
    balloon_help $cfg.l.op.refr "redraws all the panel"
    button $cfg.l.op.save -text "save" -command "save_rc $rcfile" \
        -borderwidth 1 -bg $color(high) -fg $color(fore)
    balloon_help $cfg.l.op.save "write a .tkpanelrc file"
    button $cfg.l.op.exit -text "done" -command "destroy $cfg" \
        -borderwidth 1 -bg $color(high) -fg $color(fore)
    frame $cfg.buttons -bg $color(back)
    label $cfg.buttons.lab -text "buttons" -bg $color(back) -fg $color(text)
    listbox $cfg.buttons.box -selectmode single -borderwidth 1 \
        -bg $color(back) -fg $color(text)
    label $cfg.buttons.who -text " name:" -anchor w \
        -bg $color(back) -fg $color(text) -borderwidth 1
    label $cfg.buttons.cmd -text " command:" -anchor w \
        -bg $color(back) -fg $color(text) -borderwidth 1
    label $cfg.buttons.ico -text " icon:" -anchor w \
        -bg $color(back) -fg $color(text) -borderwidth 1
    set_up_buttonlist $cfg
    frame $cfg.prop -bg $color(back)
    label $cfg.prop.lab -text "subpanels" -bg $color(back) -fg $color(text)
    listbox $cfg.prop.box  -selectmode single -borderwidth 1 \
        -bg $color(back) -fg $color(text) -borderwidth 1
    entry $cfg.prop.who -bg $color(back) -fg $color(text) -borderwidth 1
    entry $cfg.prop.cmd -bg $color(back) -fg $color(text) -borderwidth 1
    entry $cfg.prop.ico -bg $color(back) -fg $color(text) -borderwidth 1
    pack $cfg.l.pix.l $cfg.l.pix.e -side top -fill x
    pack $cfg.l.lock.l $cfg.l.lock.e -side top -fill x
    pack $cfg.l.d.pages.lab $cfg.l.d.pages.one $cfg.l.d.pages.two\
         $cfg.l.d.pages.thr $cfg.l.d.pages.four -side top
    pack $cfg.l.d.colors.lab $cfg.l.d.colors.back $cfg.l.d.colors.fore \
        $cfg.l.d.colors.high $cfg.l.d.colors.text -side top
    pack $cfg.l.d.pages $cfg.l.d.colors -side left -fill x -expand 1
    pack $cfg.l.op.set $cfg.l.op.refr $cfg.l.op.save $cfg.l.op.exit \
        -side left
    pack $cfg.l.pix $cfg.l.lock $cfg.l.d -side top -pady 5 -fill x
    pack $cfg.l.op -side bottom
    pack $cfg.buttons.lab $cfg.buttons.box $cfg.buttons.who \
        $cfg.buttons.cmd $cfg.buttons.ico -side top -fill x
    pack $cfg.prop.lab $cfg.prop.box $cfg.prop.who \
        $cfg.prop.cmd $cfg.prop.ico -side top
    pack $cfg.l $cfg.buttons $cfg.prop -side left -fill y -padx 1 -pady 1
    wm resizable $cfg 0 0
}

global cfg_button cfg_subpanel

proc set_up_buttonlist { cfg } {
    global lbuttons rbuttons cfg_button last_sel
    foreach button_data $lbuttons {
        $cfg.buttons.box insert end [lindex $button_data 0]
    }
    foreach button_data $rbuttons {
        $cfg.buttons.box insert end [lindex $button_data 0]
    }
    $cfg.buttons.box selection set 0
    bind $cfg.buttons.box <B1-ButtonRelease> {
        set cfg .style_config
        set selected [$cfg.buttons.box curselection]
        set cfg_button [ $cfg.buttons.box get $selected ]
        change_button $cfg
        set last_sel "\"button\" \"$selected\""
    }
}

proc set_up_subpanellist { cfg } {
    global subpanel cfg_button cfg_subpanel last_sel
    foreach sub_item $subpanel($cfg_button) {
        $cfg.prop.box insert end [lindex $sub_item 0]
    }
    $cfg.prop.box selection set 0
    bind $cfg.prop.box <B1-ButtonRelease> {
        set cfg .style_config
        set selected [$cfg.prop.box curselection]
        set cfg_subpanel [ $cfg.prop.box get $selected ]
        change_subpanel $cfg
        set last_sel "\"subpanel\" \"$selected\""
    }
}

proc change_button { cfg } {
    global lbuttons rbuttons subpanel cfg_button
    foreach button_data $lbuttons {
        if [ string match $cfg_button [lindex $button_data 0] ] {
            $cfg.prop.who delete 0 end
            $cfg.prop.who insert 0 "left"
            $cfg.prop.cmd delete 0 end
            $cfg.prop.cmd insert 0 [lindex $button_data 1]
            $cfg.prop.ico delete 0 end
            $cfg.prop.ico insert 0 [lindex $button_data 2]
        }
    }
    foreach button_data $rbuttons {
        if [ string match $cfg_button [lindex $button_data 0] ] {
            $cfg.prop.who delete 0 end
            $cfg.prop.who insert 0 "right"
            $cfg.prop.cmd delete 0 end
            $cfg.prop.cmd insert 0 [lindex $button_data 1]
            $cfg.prop.ico delete 0 end
            $cfg.prop.ico insert 0 [lindex $button_data 2]
        }
    }
    $cfg.buttons.who configure -text " place:"
    $cfg.prop.box delete 0 end
    if [ info exists subpanel($cfg_button) ] { set_up_subpanellist $cfg }
}

proc change_subpanel { cfg } {
    global subpanel cfg_button cfg_subpanel
    foreach sub_item $subpanel($cfg_button) {
        if [ string match $cfg_subpanel [lindex $sub_item 0] ] {
            $cfg.prop.who delete 0 end
            $cfg.prop.who insert 0 [lindex $sub_item 0]
            $cfg.prop.cmd delete 0 end
            $cfg.prop.cmd insert 0 [lindex $sub_item 1]
            $cfg.prop.ico delete 0 end
            $cfg.prop.ico insert 0 [lindex $sub_item 2]
        }
    }
    $cfg.buttons.who configure -text " name:"
}

proc set_up_changes { cfg } {
    global lbuttons rbuttons subpanel cfg_button cfg_subpanel last_sel
    set who [$cfg.prop.who get]
    set cmd [$cfg.prop.cmd get]
    set icon [$cfg.prop.ico get]
    set item_sel [lindex $last_sel 1]
#   catch {$cfg.buttons.box curselection} button_sel
#   catch {$cfg.prop.box curselection} subpanel_sel
    if [string match [lindex $last_sel 0] "button"] {
# if have left listbox (buttons) item selected
        set name [$cfg.buttons.box get $item_sel]
        set temp "\"$name\" \"$cmd\" \"$icon\""
        if [ string match $who "left" ] {
            set ix [ lsearch $lbuttons "\"$name\"*" ]
            set lbuttons [ linsert \
                [ lreplace $lbuttons $ix $ix ] $ix $temp ]
        } elseif [ string match $who "right" ] {
            set ix [ lsearch $rbuttons "\"$name\"*" ]
            set rbuttons [ linsert \
                [ lreplace $rbuttons $ix $ix ] $ix $temp ]
        }
    } elseif [string match [lindex $last_sel 0] "subpanel"] {
# or if have right listbox (subpanels) item selected
        set name [$cfg.prop.box get $item_sel]
        set temp "\"$who\" \"$cmd\" \"$icon\""
        set ix [ lsearch $subpanel($cfg_button) "\"$name\"*" ]
        set subpanel($cfg_button) [ linsert \
            [lreplace $subpanel($cfg_button) $ix $ix] $ix $temp ]
    }
}

proc change_color { index } {
    global color
    set tmpcolor [ tkColorDialog ]
    if { $tmpcolor != "" } {
        set color($index) $tmpcolor
    }
}
