# returns a image, from a gif or xpm file
proc get_icon { file } {
	puts "loading icon $file"
	if [ regexp -nocase ".gif" $file] {
		return $file
	} elseif [ regexp -nocase ".xpm" $file] {
# reads a xpm file and stores its contends to a string, and call xpm-to-image
		set string ""
		set color_sec 0
		set fileID [ open $file r ]
		while { [ gets $fileID line ] >= 0 } {
			if { [ string match "/* colors */" \
				[string tolower $line] ] } { set color_sec 1 }
			if { [ string match "/* pixels */" \
				[string tolower $line] ] } { set color_sec 0 }
			if { $color_sec } {
				regsub -nocase " c " $line "\tc " line }
			append string "$line\n"
		}
		set image [ xpm-to-image $file $string $file ]
		return $image
	}
}

# store images to a matrix
proc store_icon { file } {
	global icons_path icons
	if ![ file exists $icons_path/$file ] {
		set icons($file) $icons(default_icon) }
	if { ![ info exists icons($file) ] } {
		set icons($file) [ get_icon $icons_path/$file ]
	}
}
