# parses the .tkpanelrc file, to extracts global definitions, buttons and
# subpanels
proc save_rc { rcfile } {
	global pager_names icons_path lock_cmd color
	set fileID [ open $rcfile w ]
	puts $fileID "# created by tkpanel at [exec date]\n# edit with care."
	puts $fileID "pager $pager_names(1) $pager_names(2) $pager_names(3) $pager_names(4)"
	puts $fileID "icons_path $icons_path"
	puts $fileID "lock_cmd $lock_cmd"
	puts $fileID "colors $color(back) $color(fore) $color(high) $color(text)"
	save_buttons $fileID
#	save_subpanel is called within put_button
	close $fileID
}

# stores button values
proc save_buttons { fileID } {
	global lbuttons rbuttons subpanel
	foreach button_data $lbuttons {
		puts $fileID ""
		puts $fileID "button [lindex $button_data 0]"
		puts $fileID "\tplace left"
		puts $fileID "\tcommand [lindex $button_data 1]"
		puts $fileID "\ticon [lindex $button_data 2]"
		puts $fileID "end"
		if [info exists subpanel([lindex $button_data 0])] {
			save_subpanel $fileID [lindex $button_data 0]
		}
	}
	foreach button_data $rbuttons {
		puts $fileID ""
		puts $fileID "button [lindex $button_data 0]"
		puts $fileID "\tplace right"
		puts $fileID "\tcommand [lindex $button_data 1]"
		puts $fileID "\ticon [lindex $button_data 2]"
		puts $fileID "end"
		if [info exists subpanel([lindex $button_data 0])] {
			save_subpanel $fileID [lindex $button_data 0]
		}
	}
}

# parses the button section
proc save_subpanel { fileID name } {
	global subpanel
	foreach sub_item $subpanel($name) {
		puts $fileID ""
		puts $fileID "subpanel $name"
		puts $fileID "\tlabel [lindex $sub_item 0]"
		puts $fileID "\tcommand [lindex $sub_item 1]"
		puts $fileID "\ticon [lindex $sub_item 2]"
		puts $fileID "end"
	}
}

